// Made with Amplify Shader Editor
// Available at the Unity Asset Store - http://u3d.as/y3X 
Shader "Custom/DitherTest"
{
	Properties
	{
		_DItherRamp("DItherRamp", 2D) = "white" {}
		_DitherSteps("DitherSteps", Float) = 0
		_Scale("Scale", Float) = 0
		_AttenuateSmoothMin("AttenuateSmoothMin", Range( 0 , 1)) = 0
		_AttenuateSmoothMax("AttenuateSmoothMax", Range( 0 , 1)) = 0
		_Albedo("Albedo", 2D) = "white" {}
		[HideInInspector] _texcoord( "", 2D ) = "white" {}
		[HideInInspector] __dirty( "", Int ) = 1
	}

	SubShader
	{
		Tags{ "RenderType" = "Opaque"  "Queue" = "Geometry+0" }
		Cull Back
		CGPROGRAM
		#include "UnityPBSLighting.cginc"
		#include "UnityShaderVariables.cginc"
		#pragma target 3.0
		#pragma surface surf StandardCustomLighting keepalpha addshadow fullforwardshadows 
		struct Input
		{
			float2 uv_texcoord;
		};

		struct SurfaceOutputCustomLightingCustom
		{
			half3 Albedo;
			half3 Normal;
			half3 Emission;
			half Metallic;
			half Smoothness;
			half Occlusion;
			half Alpha;
			Input SurfInput;
			UnityGIInput GIData;
		};

		uniform sampler2D _Albedo;
		uniform float4 _Albedo_ST;
		uniform sampler2D _DItherRamp;
		uniform float _DitherSteps;
		uniform float _Scale;
		uniform float _AttenuateSmoothMin;
		uniform float _AttenuateSmoothMax;

		inline half4 LightingStandardCustomLighting( inout SurfaceOutputCustomLightingCustom s, half3 viewDir, UnityGI gi )
		{
			UnityGIInput data = s.GIData;
			Input i = s.SurfInput;
			half4 c = 0;
			#ifdef UNITY_PASS_FORWARDBASE
			float ase_lightAtten = data.atten;
			if( _LightColor0.a == 0)
			ase_lightAtten = 0;
			#else
			float3 ase_lightAttenRGB = gi.light.color / ( ( _LightColor0.rgb ) + 0.000001 );
			float ase_lightAtten = max( max( ase_lightAttenRGB.r, ase_lightAttenRGB.g ), ase_lightAttenRGB.b );
			#endif
			#if defined(HANDLE_SHADOWS_BLENDING_IN_GI)
			half bakedAtten = UnitySampleBakedOcclusion(data.lightmapUV.xy, data.worldPos);
			float zDist = dot(_WorldSpaceCameraPos - data.worldPos, UNITY_MATRIX_V[2].xyz);
			float fadeDist = UnityComputeShadowFadeDistance(data.worldPos, zDist);
			ase_lightAtten = UnityMixRealtimeAndBakedShadows(data.atten, bakedAtten, UnityComputeShadowFade(fadeDist));
			#endif
			float2 uv_Albedo = i.uv_texcoord * _Albedo_ST.xy + _Albedo_ST.zw;
			float smoothstepResult38 = smoothstep( _AttenuateSmoothMin , _AttenuateSmoothMax , ase_lightAtten);
			float clampResult39 = clamp( smoothstepResult38 , 0.0 , 0.999999 );
			float2 appendResult5 = (float2(( fmod( ( ( i.uv_texcoord.x / _DitherSteps ) * _Scale ) , ( 1.0 / _DitherSteps ) ) + ( floor( ( _DitherSteps * clampResult39 ) ) / _DitherSteps ) ) , ( i.uv_texcoord.y * _Scale )));
			#if defined(LIGHTMAP_ON) && UNITY_VERSION < 560 //aselc
			float4 ase_lightColor = 0;
			#else //aselc
			float4 ase_lightColor = _LightColor0;
			#endif //aselc
			c.rgb = ( tex2D( _Albedo, uv_Albedo ) * tex2D( _DItherRamp, appendResult5 ) * float4( ase_lightColor.rgb , 0.0 ) ).rgb;
			c.a = 1;
			return c;
		}

		inline void LightingStandardCustomLighting_GI( inout SurfaceOutputCustomLightingCustom s, UnityGIInput data, inout UnityGI gi )
		{
			s.GIData = data;
		}

		void surf( Input i , inout SurfaceOutputCustomLightingCustom o )
		{
			o.SurfInput = i;
		}

		ENDCG
	}
	Fallback "Diffuse"
	CustomEditor "ASEMaterialInspector"
}
/*ASEBEGIN
Version=15600
0;92;1641;926;2396.996;591.202;1.801329;True;False
Node;AmplifyShaderEditor.RangedFloatNode;36;-2258.761,532.0778;Float;False;Property;_AttenuateSmoothMin;AttenuateSmoothMin;3;0;Create;True;0;0;False;0;0;0.27;0;1;0;1;FLOAT;0
Node;AmplifyShaderEditor.LightAttenuation;32;-2216.806,435.4311;Float;False;0;1;FLOAT;0
Node;AmplifyShaderEditor.RangedFloatNode;37;-2256.761,605.078;Float;False;Property;_AttenuateSmoothMax;AttenuateSmoothMax;4;0;Create;True;0;0;False;0;0;0.76;0;1;0;1;FLOAT;0
Node;AmplifyShaderEditor.SmoothstepOpNode;38;-1924.359,486.0775;Float;False;3;0;FLOAT;0;False;1;FLOAT;0;False;2;FLOAT;0;False;1;FLOAT;0
Node;AmplifyShaderEditor.ClampOpNode;39;-1742.359,485.0775;Float;False;3;0;FLOAT;0;False;1;FLOAT;0;False;2;FLOAT;0.999999;False;1;FLOAT;0
Node;AmplifyShaderEditor.TextureCoordinatesNode;3;-1653.5,-126.5;Float;False;0;-1;2;3;2;SAMPLER2D;;False;0;FLOAT2;1,1;False;1;FLOAT2;0,0;False;5;FLOAT2;0;FLOAT;1;FLOAT;2;FLOAT;3;FLOAT;4
Node;AmplifyShaderEditor.RangedFloatNode;4;-1784.307,157.534;Float;False;Property;_DitherSteps;DitherSteps;1;0;Create;True;0;0;False;0;0;17;0;0;0;1;FLOAT;0
Node;AmplifyShaderEditor.RangedFloatNode;15;-1228.632,-143.0502;Float;False;Property;_Scale;Scale;2;0;Create;True;0;0;False;0;0;8;0;0;0;1;FLOAT;0
Node;AmplifyShaderEditor.SimpleMultiplyOpNode;34;-1580.484,360.7491;Float;False;2;2;0;FLOAT;0;False;1;FLOAT;0;False;1;FLOAT;0
Node;AmplifyShaderEditor.SimpleDivideOpNode;30;-1257.579,65.60344;Float;False;2;0;FLOAT;0;False;1;FLOAT;0;False;1;FLOAT;0
Node;AmplifyShaderEditor.SimpleMultiplyOpNode;14;-1090.831,75.74982;Float;False;2;2;0;FLOAT;0;False;1;FLOAT;0;False;1;FLOAT;0
Node;AmplifyShaderEditor.SimpleDivideOpNode;10;-1244.6,183.9721;Float;False;2;0;FLOAT;1;False;1;FLOAT;0;False;1;FLOAT;0
Node;AmplifyShaderEditor.FloorOpNode;35;-1427.484,362.2518;Float;False;1;0;FLOAT;0;False;1;FLOAT;0
Node;AmplifyShaderEditor.SimpleDivideOpNode;31;-1263.559,303.0231;Float;False;2;0;FLOAT;0;False;1;FLOAT;0;False;1;FLOAT;0
Node;AmplifyShaderEditor.SimpleRemainderNode;7;-926.4896,111.1878;Float;False;2;0;FLOAT;0;False;1;FLOAT;0;False;1;FLOAT;0
Node;AmplifyShaderEditor.SimpleAddOpNode;12;-741.6251,170.8954;Float;False;2;2;0;FLOAT;0;False;1;FLOAT;0;False;1;FLOAT;0
Node;AmplifyShaderEditor.SimpleMultiplyOpNode;16;-946.4896,-16.78552;Float;False;2;2;0;FLOAT;0;False;1;FLOAT;0;False;1;FLOAT;0
Node;AmplifyShaderEditor.DynamicAppendNode;5;-627.0947,27.76068;Float;False;FLOAT2;4;0;FLOAT;0;False;1;FLOAT;0;False;2;FLOAT;0;False;3;FLOAT;0;False;1;FLOAT2;0
Node;AmplifyShaderEditor.SamplerNode;40;-343.0831,-397.8097;Float;True;Property;_Albedo;Albedo;5;0;Create;True;0;0;False;0;None;85db8c0616dfe954e91b1daf5bae9e87;True;0;False;white;Auto;False;Object;-1;Auto;Texture2D;6;0;SAMPLER2D;;False;1;FLOAT2;0,0;False;2;FLOAT;0;False;3;FLOAT2;0,0;False;4;FLOAT2;0,0;False;5;FLOAT;1;False;5;COLOR;0;FLOAT;1;FLOAT;2;FLOAT;3;FLOAT;4
Node;AmplifyShaderEditor.SamplerNode;2;-472.1672,1.856533;Float;True;Property;_DItherRamp;DItherRamp;0;0;Create;True;0;0;False;0;None;5d189d76114e82a47b19ab8249be2dc5;True;0;False;white;Auto;False;Object;-1;Auto;Texture2D;6;0;SAMPLER2D;;False;1;FLOAT2;0,0;False;2;FLOAT;0;False;3;FLOAT2;0,0;False;4;FLOAT2;0,0;False;5;FLOAT;1;False;5;COLOR;0;FLOAT;1;FLOAT;2;FLOAT;3;FLOAT;4
Node;AmplifyShaderEditor.LightColorNode;48;-353.58,209.9667;Float;False;0;3;COLOR;0;FLOAT3;1;FLOAT;2
Node;AmplifyShaderEditor.SimpleMultiplyOpNode;51;-37.85607,39.84132;Float;False;3;3;0;COLOR;0,0,0,0;False;1;COLOR;0,0,0,0;False;2;FLOAT3;0,0,0;False;1;COLOR;0
Node;AmplifyShaderEditor.StandardSurfaceOutputNode;0;348.2123,-261.5716;Float;False;True;2;Float;ASEMaterialInspector;0;0;CustomLighting;Custom/DitherTest;False;False;False;False;False;False;False;False;False;False;False;False;False;False;False;False;False;False;False;False;Back;0;False;-1;0;False;-1;False;0;False;-1;0;False;-1;False;0;Opaque;0.5;True;True;0;False;Opaque;;Geometry;All;True;True;True;True;True;True;True;True;True;True;True;True;True;True;True;True;True;0;False;-1;False;0;False;-1;255;False;-1;255;False;-1;0;False;-1;0;False;-1;0;False;-1;0;False;-1;0;False;-1;0;False;-1;0;False;-1;0;False;-1;False;2;15;10;25;False;0.5;True;0;0;False;-1;0;False;-1;0;0;False;-1;0;False;-1;0;False;-1;0;False;-1;0;False;0;0,0,0,0;VertexOffset;True;False;Cylindrical;False;Relative;0;;-1;-1;-1;-1;0;False;0;0;False;-1;-1;0;False;-1;0;0;0;15;0;FLOAT3;0,0,0;False;1;FLOAT3;0,0,0;False;2;FLOAT3;0,0,0;False;3;FLOAT3;0,0,0;False;4;FLOAT;0;False;6;FLOAT3;0,0,0;False;7;FLOAT3;0,0,0;False;8;FLOAT;0;False;9;FLOAT;0;False;10;FLOAT;0;False;13;FLOAT3;0,0,0;False;11;FLOAT3;0,0,0;False;12;FLOAT3;0,0,0;False;14;FLOAT4;0,0,0,0;False;15;FLOAT3;0,0,0;False;0
WireConnection;38;0;32;0
WireConnection;38;1;36;0
WireConnection;38;2;37;0
WireConnection;39;0;38;0
WireConnection;34;0;4;0
WireConnection;34;1;39;0
WireConnection;30;0;3;1
WireConnection;30;1;4;0
WireConnection;14;0;30;0
WireConnection;14;1;15;0
WireConnection;10;1;4;0
WireConnection;35;0;34;0
WireConnection;31;0;35;0
WireConnection;31;1;4;0
WireConnection;7;0;14;0
WireConnection;7;1;10;0
WireConnection;12;0;7;0
WireConnection;12;1;31;0
WireConnection;16;0;3;2
WireConnection;16;1;15;0
WireConnection;5;0;12;0
WireConnection;5;1;16;0
WireConnection;2;1;5;0
WireConnection;51;0;40;0
WireConnection;51;1;2;0
WireConnection;51;2;48;1
WireConnection;0;13;51;0
ASEEND*/
//CHKSM=DDB94DB93A64526BD86C9DB4778C3D6D4C86833C